unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Winamp, FastDIB, FastFX;

type
  TForm1 = class(TForm)
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Bmp:   TFastDIB;
  hDC:   Integer;
  Lut:   TLut;

function  winampVisGetHeader:PwinampVisHeader;cdecl;export;
function  getModule(which:Integer):PwinampVisModule;cdecl;
procedure config(this_mod:PwinampVisModule);cdecl;
function  init(this_mod:PwinampVisModule):Integer;cdecl;
function  render(this_mod:PwinampVisModule):Integer;cdecl;
procedure quit(this_mod:PwinampVisModule);cdecl;

implementation

{$R *.DFM}

const
hdr: TwinampVisHeader =
  (version:ver;
   description:'FastLIB Winamp plugin';
   getModule:getModule);

fmod: TwinampVisModule =
  (description:'Oscilliscope';
   hwndParent:0;
   hDllInstance:0;
   sRate:0;
   nCh:0;
   latencyMs:25;
   delayMS:25;
   spectrumNch:0;
   waveformNch:2;
   Config:config;
   Init:init;
   Render:render;
   Quit:quit);

function winampVisGetHeader:PwinampVisHeader;
begin
  Result:=@hdr;
end;

function getModule(which:Integer):PwinampVisModule;
begin
  if which=0 then Result:=@fmod else Result:=nil;
end;

procedure config(this_mod:PwinampVisModule);
begin
  MessageBox(0,
    'Example Winamp Plugin using FastLIB'#13#10+
    'by: Gordy  <gfody@jps.net>'#13#10#13#10+
    'www.jps.net/gfody',
    'About',
    MB_ICONINFORMATION);
end;

function init(this_mod:PwinampVisModule):Integer;
begin
  Application.CreateForm(TForm1,Form1);
  Bmp:=TFastDIB.Create;
  Bmp.SetSize(288,128,24,0);
  hDC:=GetDC(Form1.Handle);
  Lut:=LightnessLut(-5);
end;

function render(this_mod:PwinampVisModule):Integer;
var
  x,y:   Integer;
  a,b:   PByte;
  l,r:   Byte;
  Flash: Boolean;
begin
  SplitBlur(Bmp,1);
  ApplyLut(Bmp,Lut,Lut,Lut);

  a:=@this_mod^.waveformData[0,0];
  b:=@this_mod^.waveformData[1,0];

  Flash:=False;
  for x:=0 to 287 do
  begin
    l:=(a^ xor 128)shr 1;
    r:=(b^ xor 128)shr 1;
    Bmp.Pixels24[l,x].g:=255;
    Bmp.Pixels24[r,x].b:=255;
    Bmp.Pixels24[(l+r)shr 1,x].r:=255;
    if(l=0)or(l=127)or(r=0)or(r=127)then Flash:=True;
    Inc(a,2); Inc(b,2);
  end;

  if Flash then
  begin
    Invert(Bmp);
    Bmp.Draw(hDC,0,0);
    Invert(Bmp);
  end else Bmp.Draw(hDC,0,0);

  Result:=0;
end;

procedure quit(this_mod:PwinampVisModule);
begin
  ReleaseDC(Form1.Handle,hDC);
  Form1.Close;
  Bmp.Free;
end;

end.
